			.arm
			.text
			.global JPEGDecode, JPEGSetup, JPEGDecodeIWRAM
			.include "source/defines.h"
JPEGLib_Start:			
			@DEBUG NOTES: The Quantization table has to do with the luminance, etc.  AC/DC tables have to do with reading the file (jdDecode/jdGetBits)
			@  In "Decode", an "escape" clause is commented out; never seems to get called, but slows down that critical routine.  If fail, put it back in. 
			
			@  This entire routine should be run from IWRAM for speed.
			@Some IWRAM pointers to memory locations for variables.  PUSHing on the stack is messy at best.
			@  JPEG decoder uses ~2,704 bytes of memory (676 instructions), so we can snug the memory requisites right up.
			.equ jpvWidth, 			0x00			@ BYTE (offset from the root.)  The screen's only 240 pixels across, anyway.
			.equ jpvHeight,			0x01  			@ BYTE
			.equ jpvCurX,			0x02			@ BYTE...wish we didn't need these registers.  It's all in R9...
			.equ jpvCurY,			0x03			@ BYTE
			.equ jpvRestart,		0x04			@ WORD.  Restart interval.
			.equ jpvNumComp,		0x06			@ BYTE...or nibble :-)
			
			.equ jpvSamplesY, 		0x08			@ BYTE
			.equ jpvQuantTblY,		0x09			@ BYTE.  NOTE: Code offset accessed
			.equ jpvHuffACTblY,		0x0A			@ BYTE
			.equ jpvHuffDCTblY,		0x0B			@ BYTE.  OFFSET ACCESSED (GetBlock)
			.equ jpvSamplesCbCr,	0x0C			@ BYTE.  NOTE: Never used in original code!!
			.equ jpvQuantTblCbCr,	0x0D			@ BYTE.  OFFSET ACCESSED.  This one is used.
			.equ jpvHuffACTblCbCr,	0x0E			@ BYTE
			.equ jpvHuffDCTblCbCr,	0x0F			@ BYTE.  OFFSET ACCESSED (GetBlock)
			
			.equ jpvQTables,		0x10			@ BYTE
			.equ jpvACTables,		0x11			@ BYTE
			.equ jpvDCTables,		0x12			@ BYTE
			
			.equ jpvDC_Y,			0x14			@ WORD
			.equ jpvDC_Cb,			0x16			@ WORD
			.equ jpvDC_Cr,			0x18			@ WORD
			
			@  Arrays are the bane of any small microprocessor--it's good that the GBA has a fair amount of memory, but the Propeller...
			.equ jpvHuffAmount,		0x20			@ BYTE(17)
			.equ jpvHuffDC0_L,		0x100			@ BYTE(256), Length
			.equ jpvHuffDC0_C,		0x200			@ BYTE(256), Code
			.equ jpvHuffDC0_I,		0x300			@ WORD(256), Index (UINT, 16 bit)
			.equ jpvHuffDC1_L,		0x500			@ BYTE(256), Length
			.equ jpvHuffDC1_C,		0x600			@ BYTE(256), Code
			.equ jpvHuffDC1_I,		0x700			@ WORD(256), Index
			.equ jpvHuffAC0_L,		0x900			@ BYTE(256), Length
			.equ jpvHuffAC0_C,		0xA00			@ BYTE(256), Code
			.equ jpvHuffAC0_I,		0xB00			@ WORD(256), Index
			.equ jpvHuffAC1_L,		0xD00			@ BYTE(256), Length
			.equ jpvHuffAC1_C,		0xE00			@ BYTE(256), Code
			.equ jpvHuffAC1_I,		0xF00			@ WORD(256), Index
			.equ jpvQuantTbl0,		0x1100			@ WORD(64)
			.equ jpvQuantTbl1,		0x1180			@ WORD(64)
			@  I wish these tables could be BYTEs, but +128 and -50 just don't fit.
			.equ jpvYVector1,		0x1200			@ WORD(64).  Can't indirect-access these from LDRH/STRH
			.equ jpvYVector2,		0x1280			@ WORD(64).  Need all four Y vectors for 2x2 decoding.
			.equ jpvYVector3,		0x1300			@ WORD(64)
			.equ jpvYVector4,		0x1380			@ WORD(64)
			.equ jpvCbVector,		0x1400			@ WORD(64)
			.equ jpvCrVector,		0x1480			@ WORD(64)
			@  Ooh...over 4K of arrays...
			
			@  Zig-Zag X,Y tables.  ZigZag2 = ZigZag+64.  Can only find them being put together: a waste of code and memory.
@jd_ZigZag1:	.byte 0,0,1,2,1,0,0,1,2,3,4,3,2,1,0,0,1,2,3,4,5,6,5,4,3,2,1,0,0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,2,3,4,5,6,7,7,6,5,4,3,4,5,6,7,7,6,5,6,7,7
@jd_ZigZag2:	.byte 0,1,0,0,1,2,3,2,1,0,0,1,2,3,4,5,4,3,2,1,0,0,1,2,3,4,5,6,7,6,5,4,3,2,1,0,1,2,3,4,5,6,7,7,6,5,4,3,2,3,4,5,6,7,7,6,5,4,5,6,7,7,6,7
			@  The above table put together.  Doesn't look so elegant, but "works" matter much more than "looks".  At least here.
			@Multiplied by 2, as that's the only way it's ever used.
jd_ZigZag:	.byte  0,  2, 16, 32, 18,  4,  6, 20			@  0,  1,  8, 16,  9,  2,  3, 10
			.byte 34, 48, 64, 50, 36, 22,  8, 10			@ 17, 24, 32, 25, 18, 11,  4,  5
			.byte 24, 38, 52, 66, 80, 96, 82, 68			@ 12, 19, 26, 33, 40, 48, 41, 34
			.byte 54, 40, 26, 12, 14, 28, 42, 56			@ 27, 20, 13,  6,  7, 14, 21, 28
			.byte 70, 84, 98, 112, 114, 100, 86, 72			@ 35, 42, 49, 56, 57, 50, 43, 36
			.byte 58, 44, 30, 46, 60, 74, 88, 102			@ 29, 22, 15, 23, 30, 37, 44, 51
			.byte 116, 118, 104, 90, 76, 62, 78, 92			@ 58, 59, 52, 45, 38, 31, 39, 46
			.byte 106, 120, 122, 108, 94, 110, 124, 126		@ 53, 60, 61, 54, 47, 55, 62, 63
			
			@  AA & N IDCT scaling table, 64 entries.  Precomputed values scaled up by 14 bits.
jd_AANScale:.hword 16384, 22725, 21407, 19266, 16384, 12873,  8867,  4520  
			.hword 22725, 31521, 29692, 26722, 22725, 17855, 12299,  6270
			.hword 21407, 29692, 27969, 25172, 21407, 16819, 11585,  5906
			.hword 19266, 26722, 25172, 22654, 19266, 15137, 10426,  5315
			.hword 16384, 22725, 21407, 19266, 16384, 12873,  8867,  4520
			.hword 12873, 17855, 16819, 15137, 12873, 10114,  6967,  3552
			.hword  8867, 12299, 11585, 10426,  8867,  6967,  4799,  2446
			.hword  4520,  6270,  5906,  5315,  4520,  3552,  2446,  1247
			
			@  Some constants
			.equ FIX_1_082392200, 277	@ =FIX(1.082392200)
			.equ FIX_1_414213562, 362	@ =FIX(1.414213562)
			.equ FIX_1_847759065, 473	@ =FIX(1.847759065)
			@.equ FIX_2_613125930, 669	@ =FIX(2.613125930)
			.equ FIX_NEG2_613125930, 0xFFFFFD63
			
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@																			  	@
			@  JPEGDecode: Decode a JPEG picture from (R8), blitting to (R9), assuming a	@
			@240x160 screen, permitting decoding and placement of smaller JPGs.				@
			@																				@
			@  Based on Jeff Frohwein's JPEG library, a full translation to pure ASM.		@
			@																				@
			@	R8: JPEG Picture Source Address												@
			@	R9: VRAM Output Address														@
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
JPEGDecodeIWRAM:
			mov r0, #0x03000000
			add r0, #(JPEGDecode - JPEGLib_Start) + 0x100
			bx r0
			
JPEGDecode:	push {r0-r7, r9-r12, lr}
			ldr r12, =jpVars				@ We need a lot more than just the 13 CPU registers.
			@  Reset some variables
			mov r0, #0
			strb r0, [r12, #jpvQTables]		@NOTE: Instead of resetting these, we could skip the headers after having gotten it once.
			strb r0, [r12, #jpvACTables]
			strb r0, [r12, #jpvDCTables]
			strh r0, [r12, #jpvRestart]
			strh r0, [r12, #jpvCurX]
			strh r0, [r12, #jpvCurY]
			str r0, [r12, #jpvDC_Y]			@ gets DC_Y and DC_Cb
			strh r0, [r12, #jpvDC_Cr]		@ and get the last one.
			
			@  Step 1: Is this a JPEG file?
			bl jdGetWord					@ Can't use LDRH!
			ldr r1, =0xFFD8					@ does it start right? (0xFF, 0xD8; CPU reads backwards from us)
			cmp r0, r1
			bne jdFail						@ NO, it is not valid.  Could treat as BMP???
			
			@  Yes, it's a valid JPEG file.  Search for a 0xFF, which is the JPEG escape sequence
jdStartLp:	ldrb r0, [r8], #1				@ Get a byte from the JPEG file
			cmp r0, #0xFF
			bne jdStartLp					@ We'll find a 0xFF SOMEWHERE!
			@  Found a 0xFF escape character.  What follows?
			ldrb r0, [r8], #1
			
			@-------------------------------------------------------------------------------
			@	0xC9: SOF9 - Extended sequential DCT
			@	0xFE: COM - comment
			cmp r0, #0xC9
			cmpne r0, #0xFE
			beq jdStartLp
			@	0xD9: EOI--end of information.  NOTE: This ends the JPEG file.  But if there are two scans...!
			cmp r0, #0xD9
			beq jdFail						@ We only get this at the very end!
			@-------------------------------------------------------------------------------
			@	0xC0: SOF0 (Baseline DCT)
			@	0xC1: SOF1 (Extended Sequential DCT)
			cmp r0, #0xC0
			cmpne r0, #0xC1
			bne jdSL_1						@ Not a SOF marker.
			
			@-------JPGGetImageAttr------
			add r8, r8, #2					@ Skip the segment length word
			ldrb r0, [r8], #1				@ Get the data precision
			cmp r0, #8
			bne jdFail						@ We do not support 12- or 16-bit samples.
			@  Get the picture's size and width.  We could store this in a byte...as the screen is only 240x160 in size.
			bl jdGetWord					@ Get "Height"
			cmp r0, #160
			bhi jdFail						@ Picture too big.
			strb r0, [r12, #jpvHeight]
			@  Width.
			bl jdGetWord					@ Get "Width"
			cmp r0, #240
			bhi jdFail						@ Too big.
			strb r0, [r12, #jpvWidth]
			
			@  Load the components.  We'd better have only a handful of these, as there isn't an array to store them in!
			ldrb r4, [r8], #1				@ Number of components
			@----------------------------
			@  Loop to load the component counts.
jdCompLp:	ldrb r1, [r8], #1				@ Get the component ID
			cmp r1, #1
			moveq r2, #jpvSamplesY
			movne r2, #jpvSamplesCbCr		@ the only other options being 2/3, so no concerns there.
			
			@  Get and process the data.  SamplesY/CbCr first
			ldrb r0, [r8], #1
			@Now we have to expand the number to full value.  Samples = (temp1 & 15) * (temp1 >> 4)
			lsr r1, r0, #4					@ (temp1 >> 4)
			and r0, r0, #0x0F				@ (temp1 & 15)
			mul r0, r1, r0
			strb r0, [r12, r2]				@ Store the Samples value (Y or CbCr)
			
			@ QuantTable(Y/CbCr)
			ldrb r0, [r8], #1
			add r2, r2, #1					@ Skip forward one byte
			strb r0, [r12, r2]
			@----------------------------
			@  Done with the loop yet?
			subs r4, r4, #1
			bgt jdCompLp
			b jdStartLp						@ Done.  Next tag... 
			@-------------------------------------------------------------------------------
			@	0xC4: Define Huffman Tables
jdSL_1:		cmp r0, #0xC4
			bne jdSL_2						@ Not DHT
			
			@  Have we gotten enough AC tables?
			ldrb r0, [r12, #jpvACTables]
			cmp r0, #2
			blt jdGetHuff					@ Nope
			@  DC tables?
			ldrb r0, [r12, #jpvDCTables]
			cmp r0, #2
			bge jdStartLp					@ Yes, we have gotten enough of both tables.
			
			@----------JPGGetHuffTables---------NOTE: MAY NOT BE WORKING.
jdGetHuff:	bl jdGetWord					@ Huffman table definition length
			sub r11, r0, #2					@ "L0": length of DHT structure, minus the two bytes already read.
			
			@  Starting outer main "DO" loop
jdGHT_Do:	ldrb r0, [r8], #1				@ Get "Tc", "Th".  Two four-bit values need separated from this; no "ldrn"...:-)
			sub r11, r11, #1				@ We read one more byte
			@  First, the upper four bits (endian-ness again) specify whether this is an AC or DC table.
			@The only difference between a DC and AC table is the location they're stored.  
			@That's right--the handling code is identical!  At least here :-)
			@  The lower nibble: Th - Huffman Table ID (0-1 for Baseline JPGs, 0-3 for others)
			tst r0, #0x10					@ Only 0-1 is supported for Tc (Table Class); Extended Sequential DCT can be 0-3.
			@	0: DC table
			moveq r7, #jpvHuffDC0_L
			moveq r6, #jpvDCTables
			@	1: AC table
			movne r7, #jpvHuffAC0_L
			movne r6, #jpvACTables
			@  Increment the correct table count register.
			ldrb r1, [r12, r6]
			add r1, r1, #1
			strb r1, [r12, r6]
			
			@  Determine if it's table 0 or table 1 in the DC or AC table chosen above.
			tst r0, #0x01					@ Guess we only support Baseline JPGs, not tables 0-3 of all other types
			addne r7, #256*4				@	1: move pointer to the other table.  (Default = 0.)
			
			@----------------------------
			@  Fill the HuffAmount table with the 16 "Li" entries
			add r6, r12, #jpvHuffAmount		@ Direct pointer to HuffAmount array.
			mov r5, #0						@ Reset "total"
			mov r4, #16						@ "i": #of entries to read.
			sub r11, r11, #16				@ The following loop will read 16 bytes.  Faster to keep it out of the loop.
			@  Loop to get the data
jdGHT_HTbl:	ldrb r0, [r8], #1				@ "temp1 =..." Get a byte
			strb r0, [r6], #1				@ Save it.
			add r5, r5, r0					@ "total += temp1"
			@  Loop until done
			subs r4, r4, #1
			bne jdGHT_HTbl
			
			@----------------------------NOTE: WORKING...
			@  Read all of the "codes" into the specified Huffman table.
			@	R5: "total"
			@	R7: Huffman Table "Length" pointer.  (This is NOT the HuffAmount table.)
			@	R8: JPEG Data Pointer
			@	R9: Output VRAM
			@	R11: "L0"
			@	R12: Pointer to data RAM
			sub r11, r11, r5				@ Indicate how many bytes the following loop will read.
			add r6, r7, #256				@ The "Code" entry of the Huffman table is the 2nd one.
jdGHT_HufFl:ldrb r0, [r8], #1
			strb r0, [r12, r6]
			add r6, r6, #1
			@  Keep track of where we are.
			subs r5, r5, #1
			bgt jdGHT_HufFl					@ Don't underflow
			
			@----------------------------
			@  Now we need to fill out the other entries in the table: index and bitlength
			@	R2: "CurNum"
			@	R3: Pointer to HuffAmount array
			@	R4: "I"
			@	R5: "J"
			@	R6: Offset from R7 to ".Length" of Huffman table
			@	R7: Absolute pointer to ".length" of Huffman table.  "CurIndex" is included in R6/R7.
			mov r2, #0						@ "CurNum"
			add r3, r12, #jpvHuffAmount-1	@ Indirect-access pointer to the HuffAmount table.  Accessed 1-based; correct for that.
			add r7, r7, r12					@ Convert R7 (Huffman table offset) to an absolute address
			add r6, r7, #512				@ Separate offset from ".length" to ".index" in the STRUCT, but as an absolute pointer.
			
			mov r4, #1						@ "I"; must count up.
			@ Initialize "J".  It was originally 1-based, starting from "1", but the value is never used.
			@- - - - - - - - - - - - - - - -
jdGHT_Hu_J:	ldrb r5, [r3, r4]				@ "J" = HuffAmount array (R3 = R12 + jpvHuffAmount-1); the "-1" correction for "1-based" access.
			cmp r5, #0						@ If the count is zero, don't loop.
			beq jdGHT_HuIL
			
			@  The HuffAmount is nonzero, so we can loop.
jdGHT_Hu_I:	strh r2, [r6], #2				@ .Index = "CurNum"; note that this is a 16-bit value.
			strb r4, [r7], #1				@ .Length = "I".  R7 = "CurIndex"
			add r2, r2, #1					@ "CurNum++""
			
			@  Loop for J.
			subs r5, r5, #1					@ Keep track.
			bgt jdGHT_Hu_I					@ Loop until we're done.
			@- - - - - - - - - - - - - - - -
			
			@  Loop for I.  From 1-16, due to the "Length" entry on the Huffman structure.
jdGHT_HuIL:	lsl r2, r2, #1					@ "CurNum *=2", simple bit-shift.
			add r4, r4, #1
			cmp r4, #17						@ 1-based
			blo jdGHT_Hu_J
			
			@----------------------------
			cmp r11, #0
			bgt jdGHT_Do					@ Loop until we've read all the data available.  A "NE" would work, but is not as robust.
			b jdStartLp
			@-------------------------------------------------------------------------------
			@	0xDA: Start of Scan
jdSL_2:		cmp r0, #0xDA
			bne jdSL_3						@ Not SOS
			
			@----JPGGetSOS----
			add r8, r8, #2					@ Skip the length word
			ldrb r0, [r8], #1				@ Get "Ns", the #of components in the scan.
			cmp r0, #1
			cmpne r0, #3
			bne jdFail						@ Invalid.
			@  Save the #of components; that changes how we decode it.
			strb r0, [r12, #jpvNumComp]
			@  Loop and get all the components
jdSL_SOSLp:	ldrb r1, [r8], #1				@	Cs1 (Index)
			ldrb r2, [r8], #1				@	Td1/Ta1 (Packed value: two nibbles)
			lsr r3, r2, #4					@ Extract DC table value
			and r2, r2, #0x0F				@ Extract AC table value.
			@  If the index is 1, store to the "Y" entry
			cmp r1, #1
			streqb r3, [r12, #jpvHuffDCTblY]
			streqb r2, [r12, #jpvHuffACTblY]
			@  If the index is 2/3 store to the "CbCr" entry.
			cmpne r1, #2
			cmpne r1, #3
			streqb r3, [r12, #jpvHuffDCTblCbCr]
			streqb r2, [r12, #jpvHuffACTblCbCr]
			bne jdFail						@ Invalid Huffman table ID
			
			@  Loop until we've gotten all of the table whatevers.
			subs r0, r0, #1
			bgt jdSL_SOSLp					@ in case it's zero, in which case we're in trouble.
			
			@	Se: Last DCT coefficient in a block; should be 63 for sequential DCT; 0 for lossless
			@	Ah:
			@	Al:
			add r8, r8, #3					@ Skip the last three bytes
			@--------------------------------
			@  If the JPEG has only one component, then we're done.
			ldrb r0, [r12, #jpvNumComp]
			cmp r0, #1
			beq jdMainDec					@ Yes, only one component, so only one set of tables.
			
			@  There is more than one component.  Do we have two DC tables?
			ldrb r0, [r12, #jpvDCTables]
			cmp r0, #2
			bne jdStartLp					@ Nope
			@  Two AC tables?
			ldrb r0, [r12, #jpvACTables]
			cmp r0, #2
			bne jdStartLp					@ Nope
			@  Two Q tables?
			ldrb r0, [r12, #jpvQTables]
			cmp r0, #2
			bne jdStartLp					@ Nope
			
			b jdMainDec						@ Yes, we have all the tables.  Exit out to the main decode loop.
			@-------------------------------------------------------------------------------
			@	0xDB: Define Quantization Table(s)
jdSL_3:		cmp r0, #0xDB
			bne jdSL_4						@ Not DQT
			
			@  Instead of ignoring tables, just read 'em.  There can only be two, unless it's progressive (which requires 4 tables)
			@----JPGGetQuantTables----NOTE: APPEARS FUNCTIONAL.
			bl jdGetWord
			sub r11, r0, #2					@ "L0" = length of DQT entry.  We just read two bytes.  Aha!
			
			@  Loop to read the quantization tables.
jdDQT_Loop:	ldrb r0, [r8], #1
			sub r11, r11, #1				@ We read one more byte.
			@  Make sure that the table is 8-bit
			tst r0, #0xF0
			bne jdFail						@ If the high nibble (Pq) is "1", it's 16-bit.  ERROR!
			@  Determine which quantization table to write to.  The low nibble (Tq) can be from 0-3; we only support two tables!
			tst r0, #0x0F
			addeq r7, r12, #jpvQuantTbl0	@ Absolute pointer to the specified Quantization table.  
			addne r7, r12, #jpvQuantTbl1	@ Accessed Zig-Zag style, so we need an absolute address.
			
			@	R4: "I", 0-63 (=ZigIndex)
			@	R6: AANScales pointer
			@	R7: Quantization Table address
			@	R8: JPEG Data Input
			@	R9: VRAM Output
			@	R10: ZigZag table address
			@	R11: Byte# left in the DQT structure
			@	R12: Pointer to variables
			adr r6, jd_AANScale
			adr r10, jd_ZigZag				@ Get an address to the ZigZag index list.
			mov r4, #0						@ "I"/"ZigIndex"
			sub r11, r11, #64				@ #of bytes we'll read in the loop
			@ Loop to get the Quantization Table
jdDQT_Lp:	ldrb r5, [r10, r4]				@ Get the ZigZag value from "I"/"ZigIndex".  This table is intentionally scaled up x2, as that's how we use it.
			ldrh r0, [r6, r5]				@ Get the AANScale table value.
			@  Calculate the quantization value
			ldrb r1, [r8], #1				@ Get the table data from the JPEG file
			mul r0, r1, r0					@ JPGGetByte * AANScales > R0
			asr r0, r0, #12					@ Divide it down
			@  Write the value to the Quantization Table
			strh r0, [r7, r5]				@ The input and output are Zig-Zagged to null, but the input data is what's different.
			
			@  Keep track of where we are
			add r4, r4, #1
			cmp r4, #64
			blo jdDQT_Lp					@ Loop until done.
			@  Done: Increment the table count
			ldrb r0, [r12, #jpvQTables]
			add r0, r0, #1
			strb r0, [r12, #jpvQTables]
			@  Any more bytes left?  If so, a second table has been appended on...
			cmp r11, #0
			bgt jdDQT_Loop					@ Continue on.  JPEG specification doesn't list this as an option.
			
			b jdStartLp						@ Done.
			@-------------------------------------------------------------------------------
			@	0xDD: DRI (Define Restart Interval)
jdSL_4:		cmp r0, #0xDD
			bne jdSL_5						@ Not DRI
			@  Get a 16-bit value, store to our variable for that.  NOTE: This code never uses the restart value, just if it's nonzero.
			bl jdGetWord
			strh r0, [r12, #jpvRestart]		@ R12 = root address, jpvRestart the positive offset.
			b jdStartLp
			@-------------------------------------------------------------------------------
			@	Application-specific tags: just skip and ignore them.
jdSL_5:		cmp r0, #0xFE					@ Comment
			andne r0, #0xF0
			cmpne r0, #0xE0					@APP1-15
			bne jdFail						@ unrecognized JPEG code.
			@  APP and Comment markers have a length indicator.  Skip that many bytes.
			bl jdGetWord
			sub r0, r0, #2					@ We already read two bytes: the length word!
			add r8, r8, r0					@ Just skip it!
			@	WORD: Segment Length
			@	...
			b jdStartLp
			@===============================================================================
			
			@  Start the actual decoding.  
			@	R0							R1
			@	R2							R3
			@	R4							R5: YVector Pointer (CbCr directly accessed by GetBlock)
			@	R6: Points to Y/CbCr info	R7: Pointer to DC(Y/Cb/Cr) memory location
			@	R8: JPEG data pointer		R9: VRAM Output Pointer
			@	R10: "CurByte"				R11: "CurBits"
			@	R12: Variable pointer
			@
			@  NOTE: X/Y are not in CPU registers, as they're only for bounds checks.
			@  Frohwein converted "CurBits" to 2^n, as that's just about always what it's used for.
jdMainDec:	mov r11, #128					@ CurBits = 7
			ldrb r10, [r8], #1				@ CurByte = (GetByte).  One instruction in place of a C-based subroutine :-)
			
			@  There are a couple of ways to compress a JPEG.  It can be (NumComp, SamplesY):
			@	3,4	- Color, 2x2 subsampling
			@	3,2 - Color, 2x1 subsampling
			@	3,1 - Color, 1x1 (no subsampling)
			@	1,x - Grayscale
			@  Each method requires a different decoder.  The ones most used will be 3,4 and 3,1.
			ldrb r0, [r12, #jpvNumComp]
			cmp r0, #3
			bne jdFail						@TODO: Support monochrome JPEGs...hey, they use less memory!
			@  What's the subsampling amount?
			ldrb r0, [r12, #jpvSamplesY]
			cmp r0, #1
			beq jdMainSam1
			cmp r0, #2
			beq jdFail						@TODO: Handle 2x1 subsampling at some point.
			@================================================================================
			@  Not 1 or 2, so assume 4, or 2x2 subsampling.
jdMainSam4:	add r5, r12, #jpvYVector1		@ Absolute pointer to YVector1 table
			add r6, r12, #jpvQuantTblY		@ Absolute pointer to QuantTblY (SamplesY only used for determining subsampling)
			mov r7, #jpvDC_Y				@ Relative pointer to the DC coefficient value.
			bl jdGetBlock
			@  Y2 (note, Cb/Cr still use 1/2 block for the entire thing!)
			add r5, r12, #jpvYVector2
			add r6, r12, #jpvQuantTblY
			mov r7, #jpvDC_Y
			bl jdGetBlock
			@  Y3
			add r5, r12, #jpvYVector3
			add r6, r12, #jpvQuantTblY
			mov r7, #jpvDC_Y
			bl jdGetBlock
			@  Y4
			add r5, r12, #jpvYVector4
			add r6, r12, #jpvQuantTblY
			mov r7, #jpvDC_Y
			bl jdGetBlock
			@  Cb
			add r5, r12, #jpvCbVector
			add r6, r12, #jpvQuantTblCbCr	@ Absolute pointer to QuantTblCbCr
			mov r7, #jpvDC_Cb
			bl jdGetBlock
			@  Cr.
			add r5, r12, #jpvCrVector
			add r6, r12, #jpvQuantTblCbCr	@ Absolute pointer to QuantTblCbCr
			mov r7, #jpvDC_Cr
			bl jdGetBlock
			
			@  Draw the top left square
			add r5, r12, #jpvYVector1		@ Absolute pointer to YVector1 table.  Leave R6/R7 for CbVector/CrVector
			mov r6, r12
			bl jdDraw8x8
			@  Draw the top right square
			add r9, r9, #16					@ Skip rightwards 8 pixels (16 bits/pixel)
			add r5, r12, #jpvYVector2		@ YVector2
			add r6, r12, #8
			bl jdDraw8x8
			@  Draw the lower left square
			add r9, r9, #(480*8)-16			@ Rescan to lower left
			add r5, r12, #jpvYVector3		@ YVector3
			add r6, r12, #64
			bl jdDraw8x8
			@  Draw the lower right square
			add r9, r9, #16
			add r5, r12, #jpvYVector4		@ YVector4
			add r6, r12, #64+8
			bl jdDraw8x8
			
			@  Rescan, exit.  Sure, could PUSH/POP R9, but a simple SUB fixes that.
			sub r9, r9, #(480*8)-16
			
			mov r0, #16
			bl jdMainEnd
			b jdMainSam4
			@================================================================================
			@	R4							R5: YVector Pointer (CbCr directly accessed by GetBlock)
			@	R6: Points to Y/CbCr info	R7: Pointer to DC(Y/Cb/Cr) memory location
			@  It's 1: no subsampling.
jdMainSam1:	add r5, r12, #jpvYVector1		@ Absolute pointer to YVector1 table
			add r6, r12, #jpvQuantTblY		@ Absolute pointer to QuantTblY (SamplesY only used for determining subsampling)
			mov r7, #jpvDC_Y				@ Relative pointer to the DC coefficient value.
			bl jdGetBlock
			bmi jdFail @DEBUG
			@  Cb
			add r5, r12, #jpvCbVector
			add r6, r12, #jpvQuantTblCbCr	@ Absolute pointer to QuantTblCbCr
			mov r7, #jpvDC_Cb
			bl jdGetBlock
			bmi jdFail @DEBUG
			@  Cr.  Recalculating the pointers is much faster than POP/PUSH.
			add r5, r12, #jpvCrVector
			add r6, r12, #jpvQuantTblCbCr	@ Absolute pointer to QuantTblCbCr
			mov r7, #jpvDC_Cr
			bl jdGetBlock
			bmi jdFail @DEBUG
			
			@  Now we have all three vectors.  Write an 8x8 block to the screen at (R9).
			add r5, r12, #jpvYVector1		@ Absolute pointer to YVector1 table.  Leave R6/R7 for CbVector/CrVector
			mov r6, r12
			bl jdDraw8x8
			add r9, #16						@ Skip rightwards 8 pixels (16 bits/pixel)
			
			mov r0, #8						@ #of pixels we wrote.  (2x2 subsampling will have 16 here.)
			bl jdMainEnd					@ Handle X/Y offset, determine if we're done yet.
			b jdMainSam1					@ Loop until MainEnd doesn't return.
			@================================================================================
			
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  Make sure Z is set, N clear.
jdExit:		movs r0, #0
			b jdRet
			
jdFail:		mvns r0, #0						@ Z not set, N set.
jdRet:		pop {r0-r7, r9-r12, pc}			@ Return
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  "MainEnd" routine, handling the looping parts of the JPEG decompression routine.
			@R0 = 8/16, depending on the subsampling amount.  When done, exits out.
jdMainEnd:	ldrb r1, [r12, #jpvCurX]		@ TODO: Try to find a way to calculate this from the screen address...in a way that's really fast!
			add r1, r1, r0					@ Add the width of the drawn block
			strb r1, [r12, #jpvCurX]
			@  Have we gone all the way across the picture yet?
			ldrb r2, [r12, #jpvWidth]
			cmp r1, r2
			blo jdME_OK						@ If position OK, adjust addresses, and loop again.
			
			@TODO: Implement Restart Interval on each line end.  (This also resets the DC registers.)
			
			@  "X" is too far.  Correct the VRAM address, and check "Y".
			sub r9, r9, r1, lsl #1			@ Pixels to bytes; for the first line, this =starting pixel
			mov r1, #480					@ #of bytes across one screen line
			mul r1, r0, r1					@ Multiply the block size by 480.
			add r9, r9, r1					@ Push the screen pointer out by (x) lines.  
			@  Fix "X"
			mov r1, #0
			strb r1, [r12, #jpvCurX]
			@  "Y" already handled, so now make sure we're not done drawing the picture yet.
			ldrb r1, [r12, #jpvCurY]
			add r1, r1, r0					@ Square blocks only (no 2:1)
			strb r1, [r12, #jpvCurY]
			@  Done yet?
			ldrb r2, [r12, #jpvHeight]
			cmp r1, r2
			bhs jdExit						@ Yes, we are officially done drawing this JPEG.
			
			@  Moved Y, so X needs zeroed.
			mov r1, #0
jdME_OK:	strb r1, [r12, #jpvCurX]		@ Keep track of our location either way.
			bx lr
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			.ltorg							@ for literals
			
			
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  jdDraw8x8 - Where all the other 1,000 lines of code really go to.  Draws an	@
			@8x8 block on the screen at the memory location specified by R9.  Position is	@
			@relative to this register: no X/Y registers, which would only slow things down.@
			@																				@
			@  CPU Registers:																@
			@	R0							R1												@
			@	R2							R3												@
			@	R4							R5: Y Vector Pointer							@
			@	R6: (Cb Vector)				R7: (Cr Vector)									@
			@	R8: JPEG data pointer		R9: VRAM Output Pointer							@
			@	R10: "CurByte"				R11: "CurBits"									@
			@	R12: Variable pointer														@
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
jdDraw8x8:	push {r9, r10, lr}				@ Save the VRAM location, R10 and LR for another register.
			add r7, r6, #jpvCrVector		@ Pointer to "Red" vector.
			add r6, r6, #jpvCbVector		@ Pointer to "Blue" vector
			
			@  Loop to draw the 8x8 pixel.
jdD88_Loop:	ldrsh r2, [r5], #2				@ Get "Y", post-increment.
			ldrsh r3, [r6]					@ Get "Cb".  We only use 1/2 of this array.
			ldrsh r4, [r7]					@ Get "Cr".  1/2 of this array, too.
			@  NOTE: Converting Y/Cb/Cr (R2-R4) to 5-bit R/G/B (R0-R2).  The ">>5"s and "+128"s are here, not in the IDCT routine
			add r2, r2, #128 <<5			@ The "+128"s are not in the IDCT routine.  The +128s on Cb/Cr were canceled out, so optimize it!  Only Y gets it.
			
			@   red = (y) + (((cr-128) * 45) >> 5);
			mov lr, #45 <<3
			mul r0, lr, r4					@ (Cr * 45) -> R0.
			add r0, r2, r0, asr #8			@ ASR for signed values.  Red = Yellow + (R0 >> 5).  ASR #8, as we're consolidating right here.  5+3=8
			
			@   green = y - (((cb-128) * 11) >> 5) - (((cr-128) * 23) >> 5)
			mov lr, #11 <<3
			mul r1, lr, r3					@ ...cb*11...
			sub r1, r2, r1, asr #8			@ green = y - [...] >> 5
			@  Second half.  Green sure is complicated!
			mov lr, #23 <<3
			mul r4, lr, r4					@ ...cr*23...
			sub r1, r1, r4, asr #8			@ ...-[... >> 5] 
			
			@   blue = y + (((cb-128) * 57) >> 5)
			mov lr, #57 <<3
			mul r3, lr, r3					@ (Cb * 57) -> B0.
			add r2, r2, r3, asr #8			@ blue = Y + [...] >> 5
			
			@EXPERIMENT: Does't change anything to use a CMP instead of an ASRS for the negative part of range limiting.
			@  Convert from RGB(24-bit) to BGR(15-bit.)  TODO: This should be part of the conversion routine above, or IDCT
			asr r2, r2, #8					@ Push the extra bits off of Blue
			asr r1, r1, #8					@ Green...
			asr r0, r0, #8					@ Red...
			@  Now we need to range-limit all of the values.  Ugh...more code!
			asrs r4, r0, #5					@ If nonzero, value needs reset (>31).  If negative, value needs reset (<0).
			movne r0, #31
			movmi r0, #0 
			asrs r4, r1, #5					@ Intentionally using ASR--it'll "smear" the sign bit.
			movne r1, #31
			movmi r1, #0
			asrs r4, r2, #5
			movne r2, #31
			movmi r2, #0
			@  Saved three instructions with the ASRS trick.
			
			@  Stack the rest of the values on the register.
			add r0, r0, r1, lsl #5
			add r0, r0, r2, lsl #10
			
			@  Check our location in the block, keeping track of where we are.
			@  If the "low" bit of R5 is /clear/, then increment both R6/R7 by 2.  (Halfwords here.)
			tst r5, #2
			movne r10, r0
			@  When clear...
			orreq r0, r10, r0, lsl #16		@ Stack the last 16-bit "glump" onto the current data
			streq r0, [r9], #4				@ Post-increment to the next pixels.  Noticeably faster to do a single 32-bit STR rather than two 16-bit STRHs.
			addeq r6, #2
			addeq r7, #2
			
			@  If the lowest nibble is clear (I.E. "16"), then we're on a new row.
			tst r5, #0x0F
			bne jdD88_Loop 					@ Nope, not done with this row.
			@  Yes, new screen row.
			add r9, r9, #480 - 16			@ Reposition the screen pointer, keeping in mind it's current location.
			
			@  New row for the subsampled Cb/Cr?
			tst r5, #0x1F
			moveq r0, #8					@ Yes, new row
			mvnne r0, #7					@ No, re-use old row.  (MVN 0 = -1)
			add r6, r6, r0					@ Reposition the subsampled Cb/Cr vector offsets. 
			add r7, r7, r0
			
			@  Done completely?
			tst r5, #0x7F
			bne jdD88_Loop					@ No, not yet.
			
			pop {r9, r10, pc}				@ Return.
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  jdGetBlock - The real JPEG decoding routine.  Includes "JPGDecode" ASM		@
			@routine and "jpd_idct_ifast".													@
			@																				@
			@  CPU Registers:																@
			@	R0							R1												@
			@	R2							R3												@
			@	R4							R5: ABS Vector Pointer (Y/Cb/Cr)				@
			@	R6: ABS to "QuantTblY/CbCr"	R7: Pointer to DC(Y/Cb/Cr) memory location		@
			@	R8: JPEG data pointer		R9: VRAM Output Pointer							@
			@	R10: "CurByte"				R11: "CurBits"									@
			@	R12: Variable pointer														@
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  NOTE: Ignoring JPGeoi--we can exit out anytime, as all the routines are flat here.
			@  Start out by clearing the temporary array.  Decoding will look particularly muddy without this.
			@Although we don't need to do it first, it's easier when we're not passing anything around.
			@  "EOI" doesn't appear to serve a useable purpose in most cases.  The code can't read every JPEG file, and that doesn't change it much.  
jdGetBlock:	push {lr}
			
			@NOTE: It's slower to save R5-R8, and do only four STMIAs instead of eight.  'Cause then we have to restore R5-R8!
			mov r0, r5						@ Reset the output array.
			mov r1, #0
			mov r2, #0
			mov r3, #0
			mov r4, #0
			stmia r0!, {r1-r4}				@ "ReDim array2"...
			stmia r0!, {r1-r4}
			stmia r0!, {r1-r4}
			stmia r0!, {r1-r4}
			stmia r0!, {r1-r4}
			stmia r0!, {r1-r4}
			stmia r0!, {r1-r4}
			stmia r0!, {r1-r4}
			
			@  Determine the Huffman DC table to use.
			ldrb r0, [r6, #2]				@ R6 points to QuantTbl(Y/CbCr); read the DCTbl entry
			push {r6}
			cmp r0, #0
			addeq r6, r12, #jpvHuffDC0_L	@ Pass a pointer to HuffmanDC0
			addne r6, r12, #jpvHuffDC1_L	@ HuffmanDC1
			bl jdDecode						@ Value in R0.
			pop {r6}
			popmi {pc}						@ if fail.  NOTE: NOT IN ORIGINAL, perhaps can be omitted for about 800 fewer CPU cycles...
			
			@  Get the value contained in the #of bits, and add that to the "coefficient" register offset passed in R7.
			bl jdGetBits					@ #of bits in R0, returns value in R0.
			ldrsh r1, [r12, r7]				@ Get the signed WORD DC value.  CAN BE NEGATIVE.
			add r1, r1, r0					@ dcCoef += ReceiveBits...
			strh r1, [r12, r7]				@ Save the value back.
			@  "array2(0) = dcCoef".  Frohwein code differs here from the VB6 code.
			strh r1, [r5]					@ Write the DC coefficient to the root entry of the output vector table
			
			@  Read (Byte) R6 to determine which of the two quantization tables to use.  
			@R6 will point to either "jpvQuantTblY" or "jpvQuantTblCbCr".  Set R7 to the specified table.  We never do use the "dcCoef" value again.
			ldrb r0, [r6]
			cmp r0, #0
			addeq r7, r12, #jpvQuantTbl0	@ Create an absolute pointer to the desired
			addne r7, r12, #jpvQuantTbl1	@quantization table.  We will access it with an offset from 0-63
			
			@- - - - - -JPEG Get Block Bits- - - - - - -
			@  I'm glad for all 13 registers on the ARM7TDMI now...
			@	R0							R1												@
			@	R2							R3												@
			@	R4							R5: ABS Vector Pointer (Y/Cb/Cr)				@
			@	R6: ABS to "QuantTblY/CbCr"	R7: Pointer to DC(Y/Cb/Cr) memory location		@
			@	R8: JPEG data pointer		R9: VRAM Output Pointer							@
			@	R10: "CurByte"				R11: "CurBits"									@
			@	R12: Variable pointer														@
			mov r2, #1						@ "ZigIndex".  (We already set "0" above)
			mov r3, #1						@ "ACCount"
			ldrb r0, [r6, #1]				@ R6 points to QuantTbl(Y/CbCr); read the ACTbl entry
			cmp r0, #0
			addeq r6, r12, #jpvHuffAC0_L	@ Pointer to HuffmanAC0
			addne r6, r12, #jpvHuffAC1_L	@ HuffmanAC1
			
			@  Main loop.
jdGBB_Loop:	bl jdDecode						@ Value in R0, input value in R6.
			popmi {pc}						@ if fail.  NOTE: NOT IN ORIGINAL
			
			@  Process the result.  jdDecode will return an 8-bit value that is really two nibbles.
			lsr r4, r0, #4					@ "zeroes"
			ands r0, r0, #0x0F				@ "bits".  We must know if it's zero.
			beq jdGBB_B0					@ Bitcount was zero.  Skip.  (GetBits will simply return 0 if 0 bits to read.)
			
			@  Get the #of bits specified by R0.  R0 will be nonzero.
			bl jdGetBits					@ "bitval"
			add r2, r2, r4					@ Add in "zeroes" to ZigIndex
			add r3, r3, r4					@ Ditto for "ACCount"
			@  "ACCount" high enough?
			cmp r3, #64
			bhs jdGBB_IDCT					@ Done if ACCount high enough
			
			@  Get the "ZigZag" index offset for "ZigIndex"
			adrl r1, jd_ZigZag				@ Pointer to the table
			ldrb r1, [r1, r2]				@ Get the ZigZag byte offset for the "Array" table.
			@  Set the "Array" table value.  As it's a 16-bit table, the ZigZag table has been bitshifted up one.
			strh r0, [r5, r1]				@ Write the value to the output array.
			
			@  Add a correction to ACCount and ZigIndex
			add r2, r2, #1
			add r3, r3, #1				
			b jdGBB_CLp
			@- - - - - - - - - - - - - - - -
			@  Bitcount was zero.
jdGBB_B0:	cmp r4, #15
			bne jdGBB_IDCT					@ If bits = 0, and "zeroes" <> 15, then quit.  (If =0, then "EOB encountered")
			@  Correct ZigIndex, ACCount.  NOTE: Might help speed to run the "STM" clearing as needed right here?
			add r2, r2, #15
			add r3, r3, #16
			
			@  ACCount high enough?
jdGBB_CLp:	cmp r3, #64
			blo jdGBB_Loop
			@================================
			@================================
			@================================
			@- - - - - - -JPEG IDCT Fast- - - - - - -
			@
			@  There appear to be two ways to do the IDCT routine.  There's the nice and
			@short one in the original VB6 code.  But the "DCT" array is 16KB, and requires Cosine!
			@Ouch.  The other one uses lots of registers for the same result.
			@
			@  All registers used.  Lots of PUSHing/POPping to make it all work.
			@NOTE: Assuming that the QuantTable is unsigned.  Input array is definitely signed, though.
jdGBB_IDCT:	push {r8-r12}					@ We need all the registers we can get!  We don't use these registers in this following routine.
			mov r11, r5						@ ABS pointer to the data table (Y/Cb/Cr Vector)
			mov r12, r7						@ Pointer to the quantization table (QuantTbl0/1)
			@  R10 is free.  Even so, the IDCT routine uses entirely R0-R7 for general math, R8 as a "tempreg"
			
			@--------------------------------
			@///////Even part//////
			@  tmp0 = inarray[ctr] * QuantTable[ctr]
jdGBBI_Lp1:	ldrsh r0, [r11]					@ tmp0 = inarray[ctr]...
			ldrh r8, [r12]					@ QuantTable[ctr]  
			mul r0, r8, r0					@ ...*QuantTable[ctr].  Note that the multiplicands are reversed.
			
			@  tmp1 = inarray[16+ctr] * QuantTable[16+ctr]
			ldrsh r1, [r11, #32]			@ tmp1 = inarray[ctr+16]...
			ldrh r8, [r12, #32]				@ QuantTable[ctr+16]  
			mul r1, r8, r1
			
			@  tmp2 = inarray[32+ctr] * QuantTable[32+ctr]
			ldrsh r2, [r11, #64]
			ldrh r8, [r12, #64]
			mul r2, r8, r2					@ 32-bit (signed) MUL.
			
			@  tmp3 = inarray[48+ctr] * QuantTable[48+ctr]
			ldrsh r3, [r11, #96]
			ldrh r8, [r12, #96]
			mul r3, r8, r3
			
			@  Middle calculation...
			add r4, r0, r2					@ tmp10 = tmp0 + tmp2;	/* phase 3 */
			sub r5, r0, r2					@ tmp11 = tmp0 - tmp2;
			add r7, r1, r3					@ tmp13 = tmp1 + tmp3;	/* phases 5-3 */
			sub r6, r1, r3					@ tmp12 = (((tmp1 - tmp3)...
			@  tmp12 = ... * FIX_1_414213562) >> 8) - tmp13; /* 2*c4 */
			ldr r0, =FIX_1_414213562
			mul r0, r6, r0					@ * FIX_1_414213562
			rsb r6, r7, r0, asr #8			@... >> 8) - tmp13
			
			@  Calculate the final four values
			add r0, r4, r7					@ tmp0 = tmp10 + tmp13;	/* phase 2 */
			sub r3, r4, r7					@ tmp3 = tmp10 - tmp13;
			add r1, r5, r6					@ tmp1 = tmp11 + tmp12;
			sub r2, r5, r6					@ tmp2 = tmp11 - tmp12;
			push {r0-r3}					@ Save the results.
			
			@//////Odd Part//////(and yes, it is odd :-)
			@  tmp4 = inarray[8+ctr] * QuantTable[8+ctr];
			ldrsh r4, [r11, #16]
			ldrh r8, [r12, #16]  
			mul r4, r8, r4
			
			@  tmp5 = inarray[24+ctr] * QuantTable[24+ctr];
			ldrsh r5, [r11, #48]
			ldrh r8, [r12, #48]  
			mul r5, r8, r5
			
			@  tmp6 = inarray[40+ctr] * QuantTable[40+ctr];
			ldrsh r6, [r11, #80]
			ldrh r8, [r12, #80]
			mul r6, r8, r6
			
			@  tmp7 = inarray[56+ctr] * QuantTable[56+ctr];
			ldrsh r7, [r11, #112]
			ldrh r8, [r12, #112]
			mul r7, r8, r7
			
			@  Middle calculation
			add r3, r6, r5					@ z13 = tmp6 + tmp5;		/* phase 6 */
			sub r0, r6, r5					@ z10 = tmp6 - tmp5;
			add r1, r4, r7					@ z11 = tmp4 + tmp7;
			sub r2, r4, r7					@ z12 = tmp4 - tmp7;
			
			@  Semi-final calculations...
			add r7, r1, r3					@ tmp7 = z11 + z13;		/* phase 5 */
			@  tmp11 = ((z11 - z13) * FIX_1_414213562) >> 8; /* 2*c4 */
			sub r1, r1, r3					@ tmp11 = ((z11 - z13)... (re-using "z11")
			ldr r8, =FIX_1_414213562		@ INTERESTING: If replace this with a MOV R8, #FIX... >>1, and then an ASR #7 (ditto for other use), it seems slower.
			mul r1, r8, r1					@ * FIX_1_414213562...and the >>8 is below in the "Final put-together"
			@  z5 = ((z10 + z12) * FIX_1_847759065) >> 8; /* 2*c2 */
			add r5, r0, r2					@ z5 = ((z10 + z12...
			ldr r8, =FIX_1_847759065
			mul r5, r8, r5					@ * FIX_1_847759065
			asr r5, r5, #8					@ >> 8
			@  tmp10 = ((z12 * FIX_1_082392200) >> 8) - z5; /* 2*(c2-c6) */
			ldr r8, =FIX_1_082392200
			mul r3, r2, r8					@ tmp10 = ((z12 * FIX_1_082392200)...
			rsb r3, r5, r3, asr #8			@ ... >> 8) - z5 
			@  tmp12 = ((z10 * - FIX_2_613125930) >> 8) + z5; /* -2*(c2+c6) */
			ldr r8, =FIX_NEG2_613125930
			mul r2, r0, r8					@ tmp12 = (z10 * -FIX_2_613125930)...
			add r2, r5, r2, asr #8			@ ... >> 8) + z5
			
			@  Final put-together.
			sub r6, r2, r7					@ tmp6 = tmp12 - tmp7;	/* phase 2 */
			rsb r5, r6, r1, asr #8			@ tmp5 = tmp11 - tmp6;  Note that the ASR from above is here.  More efficient!
			add r4, r3, r5					@ tmp4 = tmp10 + tmp5;
			@  Write the data to the output array.
			pop {r0-r3}
			
			add r8, r0, r7
			strh r8, [r11]					@ warray[ctr] = (tmp0 + tmp7);
			add r8, r1, r6
			strh r8, [r11, #16]				@ warray[8+ctr] = (tmp1 + tmp6);
			add r8, r2, r5
			strh r8, [r11, #32]				@ warray[16+ctr] = (tmp2 + tmp5);
			sub r8, r3, r4
			strh r8, [r11, #48]				@ warray[24+ctr] = (tmp3 - tmp4);
			add r8, r3, r4
			strh r8, [r11, #64]				@ warray[32+ctr] = (tmp3 + tmp4);
			sub r8, r2, r5
			strh r8, [r11, #80]				@ warray[40+ctr] = (tmp2 - tmp5);
			sub r8, r1, r6
			strh r8, [r11, #96]				@ warray[48+ctr] = (tmp1 - tmp6);
			sub r8, r0, r7
			strh r8, [r11, #112]			@ warray[56+ctr] = (tmp0 - tmp7);
			@=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
			@  Keep track of where we are.  Arrays are 16-bit, now.
			add r11, r11, #2				@ Vector table
			add r12, r12, #2				@ Quantization table
			tst r11, #16
			beq jdGBBI_Lp1					@ Loop through 8 iterations.
			@--------------------------------
			
			@  Fix R11 to the root address.  We don't need the quantization table any more.
			sub r11, r11, #16				@ Don't need the "QuantTbl" pointer any more.
			@--------------------------------
			@/////////Even Part////////
			@  tmp10 = warray[ctr8] + warray[ctr8+4];
			@  tmp11 = warray[ctr8] - warray[ctr8+4];
jdGBBI_Lp2:	ldrsh r8, [r11]
			ldrsh r9, [r11, #8]				@ +4...
			add r4, r8, r9					@ tmp10
			sub r5, r8, r9					@ tmp11
			@  tmp13 = warray[ctr8+2] + warray[ctr8+6];
			@  tmp12 = (((warray[ctr8+2] - warray[ctr8+6]) ...
			ldrsh r8, [r11, #4]				@ +2
			ldrsh r9, [r11, #12]			@ +6
			add r7, r8, r9					@ tmp13
			sub r6, r8, r9					@ tmp12
			@ ...* FIX_1_414213562) >> 8) - tmp13;
			ldr r8, =FIX_1_414213562
			mul r6, r8, r6					@ ...* FIX_1_414213562...
			rsb r6, r7, r6, asr #8			@ tmp12 = ... >> 8) - tmp13
			
			add r0, r4, r7					@ tmp0 = tmp10 + tmp13;
			sub r3, r4, r7					@ tmp3 = tmp10 - tmp13;
			add r1, r5, r6					@ tmp1 = tmp11 + tmp12;
			sub r2, r5, r6					@ tmp2 = tmp11 - tmp12;
			push {r0-r3}
			
			@////////Odd Part/////////
			ldrsh r8, [r11, #10]			@ +5
			ldrsh r9, [r11, #6]				@ +3
			add r3, r8, r9					@ z13 = warray[ctr8+5] + warray[ctr8+3];
			sub r0, r8, r9					@ z10 = warray[ctr8+5] - warray[ctr8+3];
			ldrsh r8, [r11, #2]				@ +1
			ldrsh r9, [r11, #14]			@ +7
			add r1, r8, r9					@ z11 = warray[ctr8+1] + warray[ctr8+7];
			sub r2, r8, r9					@ z12 = warray[ctr8+1] - warray[ctr8+7];
			
			add r7, r1, r3					@ tmp7 = z11 + z13;		/* phase 5 */
			@  tmp11 = ((z11 - z13) * FIX_1_414213562) >> 8; /* 2*c4 */
			sub r1, r1, r3					@ tmp11 = ((z11 - z13)...
			ldr r8, =FIX_1_414213562
			mul r1, r8, r1					@ ...* FIX_1_414213562...and the ASR >> 8 is below in the final put-together
			@  z5 = ((z10 + z12) * FIX_1_847759065) >> 8; /* 2*c2 */
			add r5, r0, r2					@ z5 = ((z10 + z12)...
			ldr r8, =FIX_1_847759065
			mul r5, r8, r5					@ ...* FIX_1_847759065...
			asr r5, r5, #8					@ >> 8
			
			@  tmp10 = ((z12 * FIX_1_082392200) >> 8) - z5; /* 2*(c2-c6) */
			ldr r8, =FIX_1_082392200
			mul r8, r2, r8					@ tmp10 = ((z12 * FIX_1_082392200)...
			rsb r3, r5, r8, asr #8			@ >> 8) - z5
			@  tmp12 = ((z10 * - FIX_2_613125930) >> 8) + z5; /* -2*(c2+c6) */
			ldr r8, =FIX_NEG2_613125930
			mul r8, r0, r8					@ tmp12 = ((z10 * -FIX_2_613125930)...
			add r2, r5, r8, asr #8			@ >> 8) + z5
			
			@  Final put-together
			sub r6, r2, r7					@ tmp6 = tmp12 - tmp7;	/* phase 2 */
			rsb r5, r6, r1, asr #8			@ tmp5 = tmp11 - tmp6;
			add r4, r3, r5					@ tmp4 = tmp10 + tmp5;
			@  Write the data to the output array. 
			pop {r0-r3}						@  Restore the result of the "even part."
			
			@NOTE: The +128s are all omitted, as they were promptly "SUB 128'd" in Draw8x8.
			@NOTE: >>5s all ommited, incorporated into the YCbCr->RGB conversion.
			@NOTE: Writing only 32-bit output values, so the 8 16-bit writes become four registers.  13 instructions, versus 16 for the STRH method.
			@COMPARISON: Decoding "pond2x2.jpg", CPU cycles are as follows:
			@		7,385,600 CPU cycles	-> STM R11!, [R0, R1, R2, R7].  Definitely slower to do a separate ADD R11, #16
			add r9, r0, r7					@  outarray[ctr8+0] = ((tmp0 + tmp7) >> 5)+128;		To pack...
			sub r7, r0, r7					@  outarray[ctr8+7] = ((tmp0 - tmp7) >> 5)+128;		Output = R7, goes on the high word of R3
			
			add r8, r1, r6					@  outarray[ctr8+1] = ((tmp1 + tmp6) >> 5)+128;
			add r0, r9, r8, lsl #16			@ Pack R0.  R1 free.
			sub r8, r1, r6					@  outarray[ctr8+6] = ((tmp1 - tmp6) >> 5)+128;
			add r7, r8, r7, lsl #16			@ Pack (R3).  Can't overwrite R3 yet...or at all!
			
			add r1, r2, r5					@  outarray[ctr8+2] = ((tmp2 + tmp5) >> 5)+128;		To pack...
			sub r6, r2, r5					@  outarray[ctr8+5] = ((tmp2 - tmp5) >> 5)+128;		Output = R6, goes on high word of R2 
			
			sub r8, r3, r4					@  outarray[ctr8+3] = ((tmp3 - tmp4) >> 5)+128;
			add r1, r1, r8, lsl #16			@ Pack R1.
			add r2, r3, r4					@  outarray[ctr8+4] = ((tmp3 + tmp4) >> 5)+128;
			add r2, r2, r6, lsl #16			@ Pack R2
			
			stm r11!, {r0, r1, r2, r7}		@ THE fastest input/output instruction.  Wish this could be done on the input, but...
			
@ 			@COMPARISON: Using "pond2x2.jpg", this method CPUCycles out at
@ 			@		7,436,032 when post-incrementing ->		STRH R8, [R11], #2  About 8,000 cycles slower to use a separate ADD R11
@ 			add r8, r0, r7					@  outarray[ctr8+0] = ((tmp0 + tmp7) >> 5)+128;
@ 			strh r8, [r11], #2
@ 			add r8, r1, r6					@  outarray[ctr8+1] = ((tmp1 + tmp6) >> 5)+128;
@ 			strh r8, [r11], #2
@ 			add r8, r2, r5					@  outarray[ctr8+2] = ((tmp2 + tmp5) >> 5)+128;
@ 			strh r8, [r11], #2
@ 			sub r8, r3, r4					@  outarray[ctr8+3] = ((tmp3 - tmp4) >> 5)+128;
@ 			strh r8, [r11], #2
@ 			add r8, r3, r4					@  outarray[ctr8+4] = ((tmp3 + tmp4) >> 5)+128;
@ 			strh r8, [r11], #2
@ 			sub r8, r2, r5					@  outarray[ctr8+5] = ((tmp2 - tmp5) >> 5)+128;
@ 			strh r8, [r11], #2
@ 			sub r8, r1, r6					@  outarray[ctr8+6] = ((tmp1 - tmp6) >> 5)+128;
@ 			strh r8, [r11], #2
@ 			sub r8, r0, r7					@  outarray[ctr8+7] = ((tmp0 - tmp7) >> 5)+128;
@ 			strh r8, [r11], #2
			@=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
			@  Keep track of where we are.  R11 +=16 handled in STRH/STM above.
			tst r11, #0x7F					@ Check if we left the array with the above ADD.
			bne jdGBBI_Lp2					@ Loop through 8 iterations.
			@--------------------------------
			@  Restore the stack, exit.  No need to restore the output array's address.
			pop {r8-r12, pc}				@ Restore the JPEG decoding registers
			@================================
			.ltorg
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  Decode routine searches the specified table for the matching entry.  Perhaps	@
			@it can be optimized???  APPEARS TO WORK.										@
			@  Huffman Table address input in R6; coefficient value returned in R0.			@
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  About 8,000 cycles faster to have the input in R6, rather than R4...and about 10,000 cycles faster for each register not PUSHed/POPped.
			@  R1/R4 overwritten after the two uses of jdDecode.  R2/R3 are the loop registers.
jdDecode:	push {r2-r3, r6, lr}			@ Save context.  Makes it easier on other routines.
			
			ldrb r3, [r8]					@ Get a byte from the JPEG stream for comparison purposes...but don't post-increment.
			cmp r3, #255
			bne jdGB_N255					@ And guess what...no need to decrement R8, because we didn't increment it!
			@  Byte = 255.  Peek at the next byte.
			ldrb r3, [r8, #1]				@ Don't post-increment...and then we don't need to decrement R8!
			and r3, r3, #0xF0				@ Checking to see if it is in the range 0xD0-7
			cmp r3, #0xD0
			bne jdGB_N255					@ Not in the specified range, so act like nothing happened.  This only for JPEG sizes not divisible by 8??
			@  The value is between 0xD0 and 0xD7.  If CurByte = (CurBits-1), then exit the function.
			sub r3, r11, #1					@ Could end up "0"...although the original calculation won't.
			and r2, r10, r3					@ Mask CurByte with CurBits -1.  NOTE: THIS WILL NOT FUNCTION THE SAME AS THE VB6 CODE!
			cmp r2, r3						@ If a match.
			moveq r0, #0
			beq jdDecRet					@ Return zero
			@--------------------------------
			@	R0 = G.P. variable, just the return value has to be correct. 
			@	R1 = CurVal
			@	R2 = "L"
			@	R3 = "I"
			@	R4 = Huffman Table pointer, pointing to ".length"
jdGB_N255:	mov r1, #0
			mov r2, #1						@ "L" is 1-based for comparison
			mov r3, #0						@ Don't reset R3 in the loop--all bitlengths are sequential, anyway.
			add r4, r6, #512				@ Point to ".index".  R4 = HuffTable root address (.length)
			@  NOTE: R3 is 2-based, as LDRB can "LSR", and LDRH cannot.  Saves a line of code.
			
jdDecFLoop:	bl jdNextBit					@ Returns 0/1 in R0.
		@	bmi jdDecRet					@ If "N" (=EOI), then exit the routine.  NOTE: Not planning for invalid JPEGs!
			add r1, r0, r1, lsl #1			@ One C line = one ASM line.  How nice!  R1 = R1 << 1 + R0
			@  Inner loop to search for a matching bitlength.
jdDecILoop:	ldrb r0, [r6, r3, lsr #1]		@ Read a ".length" byte from the table.
			cmp r0, r2						@ Compare the current "L" with what we read.
			bhi jdDecFL_L					@ What we read is higher.  Check the next set of bitlengths...
		@	bne jdDecI_NMt					@ If the bitlength does not match, skip.  DEBUG: Faster without this, and never ever seems to happen.
			@  OK, length matches.  Does ".index" = Curval?
			ldrh r0, [r4, r3]				@ Load the ".index" value of the Huffman table.  Can't add the LSL here...
			cmp r0, r1						@ Is the ".index" a match with "CurVal"?
			beq jdDecCMatch					@ Yes, it matches.  Exit, get the code.
			
			@  No, not a match.  Loop some more.
jdDecI_NMt:	add r3, r3, #2
			cmp r3, #512					@ 256 counts, as we're adding 2 each time.
			blo jdDecILoop					@ Loop until done
			@  Outer loop.
jdDecFL_L:	add r2, r2, #1
			cmp r2, #16
			bls jdDecFLoop					@ Outer loop, from 1-16, so stop at 17.
			@  If we didn't find a match, there's quite a problem.  Return -1, N set.
			mvns r0, #0
			b jdDecRet
			@--------------------------------
			@ ".index" = "CurVal", so return the ".code" in R0.
jdDecCMatch:add r6, r6, #256				@ from ".length" to ".code"
			ldrb r0, [r6, r3, lsr #1]		@ Get the byte.
jdDecRet:	pop {r2-r3, r6, pc}
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			
			
			
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  Small routines to help the JPEG decoding routine								@
			@jdGetWord - get 16 bits from (R8) -> R4, as the LDRH command must be aligned.	@
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
jdGetWord:	push {r1}						@ Nobody likes to lose a variable!
			ldrb r1, [r8], #1
			ldrb r0, [r8], #1
			orr r0, r0, r1, lsl #8
			pop {r1}
			bx lr
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  jdNextBit - Get one bit from the JPEG file to R0.							@
			@	R0: Output 0/1																@
			@	R10: "CurByte"																@
			@	R11: "CurBits"																@ 
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  WORKING.  NOTE: Have been considering outputting the data in Carry, using ADCs for bit-building routines.  Challenges with bitflags, though.
jdNextBit:	lsr r0, r10, #7					@ Get the top bit from "CurByte".  JPEGs appear to be MSB-first.  Logical when you think about it...
			and r0, r0, #1					@TODO: Optimize this.  Frohwein code gets by with the LDRB 8-bit rule.  There has to be a way to do this easily!
			lsl r10, r10, #1				@ Push "CurByte" up one.  (NOTE: Frohwein code stores the shifted value, but reads the unshifted value.)
			lsrs r11, r11, #1				@ One less bit, and let us know if it's time to get more.
			bxne lr							@ Done.  Isn't true ASM beautiful?  10 "C-style ASM" lines to 5...
			@  OK, we need to load another byte into the register
			mov r11, #128
			ldrb r10, [r8], #1				@ Get another byte
			@  Does it =0xFF?
			cmp r10, #0xFF
			addeq r8, r8, #1				@ Skip the next byte, which should be 0x00 (an escape sequence.)  If it isn't, never mind.  The less code, the better.
			movnes lr, lr					@ Ensure that "N" is clear, as that's the "EOI" signal.  TOOD: Check, see if this is necessary.  Probably is.
			bx lr							@ Exit: not an escape sequence.
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  jdGetBits - Get the #of bits in R0, output in R0.  Result is signed.			@
			@	R0: #of bits to get, output value											@
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			@  Note that the very first bit we read is the sign bit.  Of course, if we're asked
			@to read 0 bits, exit.  TESTED FUNCTIONAL...Frohwein code provides same result, only with 17 instructions.
jdGetBits:	push {r1-r2, lr}				@ We have to call NextBit, and it's good to save some context
			subs r2, r0, #1					@ Move the bitcount, but also see if there's anything to do.  NOTE: IS NOT IN VB6 CODE.
			bmi jdGB_Ret					@ Nothing to get (0-1 = -1)
			
			@  Get the sign bit.
			bl jdNextBit
			movs r1, r0						@ Update Z while we're at it--was it a one or a zero?
			mvneq r1, #1					@ It was a zero, so set almost all of the bits in our accumulator: negative.  (Backwards, I know.)
			@Sign bit 0 = "-2", sign bit 1 = 1.
			cmp r2, #0
			beq jdGB_Fix
			
			@  Loop to get the data.
jdGB_Loop:	bl jdNextBit					@NOTE: No exit-out if error from NextBit.  Not planning for invalid JPEGs...
			add r1, r0, r1, lsl #1			@ Shift the data bit in place
			subs r2, r2, #1					@ We have to check up here: if Bits = 1, then don't read any more--we already read one bit!
			bne jdGB_Loop					@ Exit if done. 
			
			@  OK, if R1 is signed, we need to add one to it
jdGB_Fix:	movs r0, r1						@ move it while we're at it!
			addmi r0, r0, #1				@ Make it a full negate if bit 31 is set.
jdGB_Ret:	pop {r1-r2, pc}					@ Return; in the case of 0 bits, it'll return zero.
			@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
JPEGLib_End:

			.equ JLibLen, JPEGLib_End - JPEGLib_Start
JPEGSetup:	adrl r0, JPEGLib_Start
			mov r1, #0x03000000
			add r1, r1, #0x100				@ for general-purpose variables.
			ldr r2, =JLibLen
			@  BIOS MemCopy is troublesome to use!
jpsLoop:	ldr r3, [r0], #4
			str r3, [r1], #4
			subs r2, r2, #4
			bne jpsLoop
			
			bx lr
			
